<?php
	require_once('config.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	require_once('lib/referrers.php');
	require_once('lib/user_agents.php');
	require_once('lib/controls.php');
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$report_name = 'Browsers';

	$start_date_values = get_date_control_value($_GET, 'start_date');
	$start_date = $start_date_values[0];
	$end_date_values = get_date_control_value($_GET, 'end_date');
	$end_date = $end_date_values[0];

	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);

	$res =& $db->query('SELECT MIN(YEAR(first_hit)), MAX(YEAR(first_hit)) FROM session');
	if (PEAR::isError($res)) { die($res->getMessage()); }
	$row = $res->fetchRow(DB_FETCHMODE_ORDERED);
	$min_year = $row[0]; $max_year = $row[1];
	$res->free();
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>

<form method="get" action="browsers.php">
	<input type="hidden" name="server_id" value="<?= $server_id; ?>" />
	Dates:
		<?= insert_date_control($_GET, 'start_date', $min_year, $max_year) ?>
	through
		<?= insert_date_control($_GET, 'end_date', $min_year, $max_year) ?>
	<input type="submit" name="go" value="Filter" />
</form>

<?php
	$browser_names = array();
	$browsers = array();

	$args = array();
	$sql = 'SELECT user_agent, COUNT(session_id) FROM session';
	if (!empty($start_date))
	{
		$sql = $sql . ' WHERE TO_DAYS(first_hit) >= TO_DAYS(?)';
		array_push($args, $start_date);
	}
	if (!empty($end_date))
	{
		$sql = $sql . (!empty($start_date) ? ' AND ' : ' WHERE ');
		$sql = $sql . 'TO_DAYS(last_hit) <= TO_DAYS(?)';
		array_push($args, $end_date);
	}
	$sql = $sql . ' GROUP BY user_agent';

	$res =& $db->query($sql, $args);
	if (PEAR::isError($res)) { die($res->getMessage()); }
	while ($row =& $res->fetchRow(DB_FETCHMODE_ORDERED))
	{
		$client_data = parse_user_agent($row[0]);
		if (empty($client_data['browser'])) { $client_data['browser'] = 'Unknown'; }
		if (empty($client_data['browser_name'])) { $client_data['browser_name'] = 'Unknown'; }
		
		if (array_key_exists($client_data['browser'], $browsers)) { $browsers[$client_data['browser']] += $row[1]; }
		else { $browsers[$client_data['browser']] = $row[1]; }

		if (array_key_exists($client_data['browser_name'], $browser_names)) { $browser_names[$client_data['browser_name']] += $row[1]; }
		else { $browser_names[$client_data['browser_name']] = $row[1]; }
		
	}
	$res->free();
	arsort($browsers);
	arsort($browser_names);
?>

<h2>Browsers By Name</h2>
<table class="data_table" cellspacing="0">
	<tr>
		<th>Platform</th>
		<th>Count</th>
	</tr>
	<?php foreach (array_keys($browser_names) as $browser) { ?>
		<tr>
			<td><?= htmlspecialchars($browser) ?></td>
			<td class="numeric"><?= $browser_names[$browser] ?></td>
		</tr>
	<?php } ?>
</table>

<h2>Browsers By Name and Version</h2>
<table class="data_table" cellspacing="0">
	<tr>
		<th>Platform</th>
		<th>Count</th>
	</tr>
	<?php foreach (array_keys($browsers) as $browser) { ?>
		<tr>
			<td><?= htmlspecialchars($browser) ?></td>
			<td class="numeric"><?= $browsers[$browser] ?></td>
		</tr>
	<?php } ?>
</table>

<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
