<?php
	require_once('config.php');
	require_once('lib/controls.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$group_by = !empty($_GET['group_by']) ? $_GET['group_by'] : 'DATE';
	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>
	
	<form method="get" action="index.php">
		<input type="hidden" name="server_id" value="<?= $server_id ?>" />
		Group By: <select name="group_by" onchange="this.form.submit();">
			<option value="<?= GROUP_BY_DATE ?>"<?= ($group_by==GROUP_BY_DATE) ? ' selected' : '' ?>>Session Date</option>
			<option value="<?= GROUP_BY_HOST ?>"<?= ($group_by==GROUP_BY_HOST) ? ' selected' : '' ?>>Hostname</option>
		</select>
	</form>

<?php
	switch ($group_by)
	{
		case GROUP_BY_DATE:
			$table_header = 'Date';
			$url = 'sessions_by_date.php';
			$sql = 'SELECT DATE_FORMAT(first_hit, "%Y-%m-%d"), DATE_FORMAT(first_hit, "%M %d, %Y"), COUNT(session_id)
					FROM session
					GROUP BY TO_DAYS(first_hit)
					ORDER BY first_hit DESC';
			break;
		case GROUP_BY_HOST:
			$table_header = 'Domain';
			$url = 'sessions_by_domain.php';
			$sql = 'SELECT domain_name, domain_name, COUNT(session_id)
					FROM session
					GROUP BY domain_name
					ORDER BY domain_name';
			break;
		default:
			$table_header = '';
			$url = '';
			$sql = '';
	}
?>

<table class="data_table" cellspacing="0">
	<tr>
		<th><?= $table_header ?></th>
	</tr>
	<?php
		$res =& $db->query($sql);
		if (PEAR::isError($res)) { die($res->getMessage()); }
		$count = 0;
		while($row =& $res->fetchRow(DB_FETCHMODE_ORDERED))
		{
			$link = get_websessions_link($url, $server_id, $group_by, $row[0]);
			?>
			<tr<?= ($count % 2 == 1) ? ' class="altRow"' : '' ?>>
				<td><a href="<?= $link ?>"><?= $row[1]; ?></a> (<?= $row[2] ?> sessions)</td>
			</tr><?php
			$count++;
		}		
		$res->free();
	?>
</table>

<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
