<?php

function display_referrer($referrer)
{
	$seinfo = get_search_engine_info($referrer);
	if (!empty($seinfo[0]))
	{
		return htmlspecialchars($seinfo[0]) . ' (' . htmlspecialchars($seinfo[1]) . ')<br />' . htmlspecialchars($seinfo[2]);
	}
	else 
	{
		return htmlspecialchars($referrer);
	}
}


function get_search_engine_info($referrer)
{
	global $search_referrers;
	$url_parts = parse_url($referrer);

	$base_host = (strtolower(substr($url_parts['host'], 0, 4)=='www.')) ? substr($url_parts['host'], 4, strlen($url_parts['host'])-4) : $url_parts['host'];

	$rule = null;
	for ($i = 0; $i < count($search_referrers); $i++)
	{
		for ($j = 0; $j < count($search_referrers[$i]['hostnames']); $j++)
		{
			if ($base_host == $search_referrers[$i]['hostnames'][$j])
			{
				$params = parse_query_string($url_parts['query']);
				if (!empty($params[$search_referrers[$i]['keyword']]))
				{
					$rule = $search_referrers[$i];
					break;
				}
			}
		}
		if ($rule != null) { break; }
	}
	if ($rule == null) { return array(null, null, null); }
	else { return array($rule['name'], $base_host, $params[$rule['keyword']]); }
}


function parse_query_string($qstr)
{
	$values = array();

	$params = explode('&', $qstr);
	for ($i = 0; $i < count($params); $i++)
	{
		$kv = explode('=', $params[$i]);
		$key = $kv[0]; $value = $kv[1];
		$values[urldecode($key)] = urldecode(str_replace('+', '%20', $value));
	}

	return $values;	
}

?>
