<?php

// Web Browser Identifier v0.5
// Written by Marcin Krol <hawk@limanowa.net>
// License: free for non-commercial use

function parse_user_agent($user_agent)
{
    $client_data = array(
    'system' => "",
    'browser' => "",
	'browser_name' => "",
    );
    $tmp_array = array();

    // 
    // Check browsers
    // 
  
    // Camino
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*camino\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Camino";
	      $client_data['browser'] = "Camino" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Netscape
    if(preg_match('/mozilla.*netscape[0-9]?\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
	  $client_data['browser_name'] = "Netscape";
      $client_data['browser'] = "Netscape" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Epiphany
    if(preg_match('/mozilla.*gecko\/[0-9]+.*epiphany\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
	  $client_data['browser_name'] = "Epiphany";
      $client_data['browser'] = "Epiphany" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Galeon
    if(preg_match('/mozilla.*gecko\/[0-9]+.*galeon\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Galeon";
      $client_data['browser'] = "Galeon" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Flock
    if(preg_match('/mozilla.*gecko\/[0-9]+.*flock\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Flock";
		  $client_data['browser'] = "Flock" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Minimo
    if(preg_match('/mozilla.*gecko\/[0-9]+.*minimo\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Minimo";
      $client_data['browser'] = "Minimo" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // K-Meleon
    if(preg_match('/mozilla.*gecko\/[0-9]+.*k\-meleon\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "K-Meleon";
      $client_data['browser'] = "K-Meleon" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // K-Ninja
    if(preg_match('/mozilla.*gecko\/[0-9]+.*k-ninja\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "K-Ninja";
      $client_data['browser'] = "K-Ninja" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Kazehakase
    if(preg_match('/mozilla.*gecko\/[0-9]+.*kazehakase\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Kazehakase";
      $client_data['browser'] = "Kazehakase" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // SeaMonkey
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*seamonkey\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "SeaMonkey";
      $client_data['browser'] = "SeaMonkey" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Firefox
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*firefox\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Firefox";
      $client_data['browser'] = "Firefox" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // IceWeasel
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*iceweasel\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "IceWeasel";
      $client_data['browser'] = "IceWeasel" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Bon Echo
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*BonEcho\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Bon Echo";
      $client_data['browser'] = "Bon Echo" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Minefield
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*Minefield\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Minefield";
      $client_data['browser'] = "Minefield" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Thunderbird
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*thunderbird\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Thunderbird";
      $client_data['browser'] = "Thunderbird" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Firebird
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*firebird\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Firebird";
      $client_data['browser'] = "Firebird" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Phoenix
    if(preg_match('/mozilla.*rv:[0-9\.]+.*gecko\/[0-9]+.*phoenix\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Phoenix";
      $client_data['browser'] = "Phoenix" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Mozilla Suite
    if(preg_match('/mozilla.*rv:([0-9\.]+).*gecko\/[0-9]+.*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Mozilla";
      $client_data['browser'] = "Mozilla";
    // Last official version was 1.7.13, drop all versions where second number > 7
    if((int)substr($tmp_array[1],2,1) <= 7)
      {
      $client_data['browser'] .= ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }
    else
      {
		  $client_data['browser_name'] .= " compatible";
      $client_data['browser'] .= " compatible";
      }
    }

    // Konqueror
    if(preg_match('/mozilla.*konqueror\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
	  $client_data['browser_name'] = "Konqueror";
      $client_data['browser'] = "Konqueror" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      if(preg_match('/khtml\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array))
        {
        $client_data['browser'] = "Konqueror" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Opera
    if((preg_match('/mozilla.*opera ([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) || preg_match('/^opera\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array)) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Opera";
      $client_data['browser'] = "Opera" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      if(preg_match('/opera mini/si', $user_agent))
        {
        preg_match('/opera mini\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array);
        $client_data['browser'] .= " (Opera Mini" . ($tmp_array[1] ? " ".$tmp_array[1] : "") . ")";
        }
    }

    // OmniWeb
    if(preg_match('/mozilla.*applewebkit\/[0-9]+.*omniweb\/v[0-9\.]+/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "OmniWeb";
      $client_data['browser'] = "OmniWeb";
      }

    // SunriseBrowser
    if(preg_match('/mozilla.*applewebkit\/[0-9]+.*sunrisebrowser\/([0-9a-z\+\-\.]+)/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "SunriseBrowser";
      $client_data['browser'] = "SunriseBrowser" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // DeskBrowse
    if(preg_match('/mozilla.*applewebkit\/[0-9]+.*deskbrowse\/([0-9a-z\+\-\.]+)/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "DeskBrowse";
      $client_data['browser'] = "DeskBrowse" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Shiira
    if(preg_match('/mozilla.*applewebkit.*shiira\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Shiira";
      $client_data['browser'] = "Shiira" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Safari
    if(preg_match('/mozilla.*applewebkit.*safari\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Safari";
      $client_data['browser'] = "Safari";

      // Translate Safari build into version number
      if(substr($tmp_array[1], 0, 3) == "419")
        {
        $client_data['browser'] .= " 2.0.4";
        }
      elseif(substr($tmp_array[1], 0, 3) == "417")
        {
        $client_data['browser'] .= " 2.0.3";
        }
      elseif(substr($tmp_array[1], 0, 3) == "416")
        {
        $client_data['browser'] .= " 2.0.2";
        }
      elseif($tmp_array[1] == "412.5")
        {
        $client_data['browser'] .= " 2.0.1";
        }
      elseif(substr($tmp_array[1], 0, 3) == "412")
        {
        $client_data['browser'] .= " 2.0";
        }
      elseif($tmp_array[1] == "312.6" || $tmp_array[1] == "312.5")
        {
        $client_data['browser'] .= " 1.3.2";
        }
      elseif(substr($tmp_array[1], 0, 5) == "312.3")
        {
        $client_data['browser'] .= " 1.3.1";
        }
      elseif(substr($tmp_array[1], 0, 3) == "312")
        {
        $client_data['browser'] .= " 1.3";
        }
      elseif($tmp_array[1] == "125.12" || $tmp_array[1] == "125.11")
        {
        $client_data['browser'] .= " 1.2.4";
        }
      elseif($tmp_array[1] == "125.9")
        {
        $client_data['browser'] .= " 1.2.3";
        }
      elseif($tmp_array[1] == "125.8" || $tmp_array[1] == "125.7")
        {
        $client_data['browser'] .= " 1.2.2";
        }
      elseif($tmp_array[1] == "125.1")
        {
        $client_data['browser'] .= " 1.2.1";
        }
      elseif(substr($tmp_array[1], 0, 3) == "125")
        {
        $client_data['browser'] .= " 1.2";
        }
      elseif($tmp_array[1] == "101.1")
        {
        $client_data['browser'] .= " 1.1.1";
        }
      elseif(substr($tmp_array[1], 0, 3) == "100")
        {
        $client_data['browser'] .= " 1.1";
        }
      elseif(substr($tmp_array[1], 0, 4) == "85.8")
        {
        $client_data['browser'] .= " 1.0.3";
        }
      elseif($tmp_array[1] == "85.7")
        {
        $client_data['browser'] .= " 1.0.2";
        }
      elseif(substr($tmp_array[1], 0, 2) == "85")
        {
        $client_data['browser'] .= " 1.0";
        }
      elseif(substr($tmp_array[1], 0, 2) == "74")
        {
        $client_data['browser'] .= " 1.0b2";
        }
      elseif(substr($tmp_array[1], 0, 2) == "73")
        {
        $client_data['browser'] .= " 0.9";
        }
      elseif(substr($tmp_array[1], 0, 2) == "60")
        {
        $client_data['browser'] .= " 0.8.2";
        }
      elseif(substr($tmp_array[1], 0, 2) == "51")
        {
        $client_data['browser'] .= " 0.8.1";
        }
      elseif(substr($tmp_array[1], 0, 2) == "48")
        {
        $client_data['browser'] .= " 0.8";
        }
      }
  
    // Dillo
    if(preg_match('/dillo\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Dillo";
      $client_data['browser'] = "Dillo" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // iCab
    if(preg_match('/icab\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "iCab";
      $client_data['browser'] = "iCab" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Lynx
    if(preg_match('/^lynx\/([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Lynx";
      $client_data['browser'] = "Lynx" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Links
    if(preg_match('/^links \(([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Links";
      $client_data['browser'] = "Links" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Elinks
    if(preg_match('/^elinks \(([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "ELinks";
      $client_data['browser'] = "ELinks" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }
    if(preg_match('/^elinks\/([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "ELinks";
      $client_data['browser'] = "ELinks" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }
    if(preg_match('/^elinks$/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "ELinks";
      $client_data['browser'] = "ELinks";
      }

    // Wget
    if(preg_match('/^Wget\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Wget";
      $client_data['browser'] = "Wget" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Amiga Aweb
    if(preg_match('/Amiga\-Aweb\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Amiga Aweb";
      $client_data['browser'] = "Amiga Aweb" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Amiga Voyager
    if(preg_match('/AmigaVoyager\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Amiga Voyager";
      $client_data['browser'] = "Amiga Voyager" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // QNX Voyager
    if(preg_match('/QNX Voyager ([0-9a-z.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "QNX Voyager";
      $client_data['browser'] = "QNX Voyager" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // IBrowse
    if(preg_match('/IBrowse\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "IBrowse";
      $client_data['browser'] = "IBrowse" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Openwave
    if(preg_match('/UP\.Browser\/([0-9a-zA-Z\.]+).*/s', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Openwave";
      $client_data['browser'] = "Openwave" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }
    if(preg_match('/UP\/([0-9a-zA-Z\.]+).*/s', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Openwave";
      $client_data['browser'] = "Openwave" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // NetFront
    if(preg_match('/NetFront\/([0-9a-z\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Netfront";
      $client_data['browser'] = "NetFront" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // PlayStation Portable
    if(preg_match('/psp.*playstation.*portable[^0-9]*([0-9a-z\.]+)\)/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "PSP";
      $client_data['browser'] = "PSP" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Various robots...

    // Googlebot
    if(preg_match('/Googlebot\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Googlebot";
      $client_data['browser'] = "Googlebot" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Googlebot Image
    if(preg_match('/Googlebot\-Image\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Googlebot Image";
      $client_data['browser'] = "Googlebot Image " . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Gigabot
    if(preg_match('/Gigabot\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Gigabot";
      $client_data['browser'] = "Gigabot" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // W3C Validator
    if(preg_match('/^W3C_Validator\/([0-9a-z\+\-\.]+)$/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "W3C Validator";
      $client_data['browser'] = "W3C Validator" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // W3C CSS Validator
    if(preg_match('/W3C_CSS_Validator_[a-z]+\/([0-9a-z\+\-\.]+)$/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "W3C CSS Validator";
      $client_data['browser'] = "W3C CSS Validator" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // MSN Bot
    if(preg_match('/msnbot\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "MSNBot";
      $client_data['browser'] = "MSNBot" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // cfetch/voyager
    if(preg_match('/^(cfetch|voyager)\/([0-9a-z\+\-\.]+)$/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "voyager";
      $client_data['browser'] = "voyager" . ($tmp_array[2] ? " ".$tmp_array[2] : "");
      }

    // BecomeBot
    if(preg_match('/BecomeBot\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "BecomeBot";
      $client_data['browser'] = "BecomeBot" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Alexa
    if(preg_match('/^ia_archiver$/si', $user_agent) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Alexa";
      $client_data['browser'] = "Alexa";
      }

    // Inktomi Slurp
    if(preg_match('/slurp.*inktomi/si', $user_agent) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Inktomi Slurp";
      $client_data['browser'] = "Inktomi Slurp";
      }

    // Yahoo Slurp
    if(preg_match('/yahoo!.*slurp/si', $user_agent) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Yahoo! Slurp";
      $client_data['browser'] = "Yahoo! Slurp";
      }

    // Ask.com
    if(preg_match('/Ask Jeeves\/Teoma/si', $user_agent) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Ask.com";
      $client_data['browser'] = "Ask.com";
      }

    // end of robots

    // MSIE
    if(preg_match('/microsoft.*internet.*explorer/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Microsoft Internet Explorer";
      $client_data['browser'] = "Microsoft Internet Explorer 1.0";
      }
    if(preg_match('/mozilla.*MSIE ([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Microsoft Internet Explorer";
      $client_data['browser'] = "Microsoft Internet Explorer" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Netscape Navigator
    if(preg_match('/Mozilla\/([0-4][0-9\.]+).*/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Netscape Navigator";
      $client_data['browser'] = "Netscape Navigator" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Catchall for other Mozilla compatible browsers
    if(preg_match('/mozilla/si', $user_agent, $tmp_array) && !$client_data['browser'])
      {
		  $client_data['browser_name'] = "Mozilla Compatible";
      $client_data['browser'] = "Mozilla compatible";
      }

    // 
    // Check system
    // 

    // Linux
    if(preg_match('/linux/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "Linux";
      if(preg_match('/mdk/si', $user_agent))
        {
        $client_data['system'] .= " (Mandrake)";
        }
      elseif(preg_match('/kanotix/si', $user_agent))
        {
        $client_data['system'] .= " (Kanotix)";
        }
      elseif(preg_match('/lycoris/si', $user_agent))
        {
        $client_data['system'] .= " (Lycoris)";
        }
      elseif(preg_match('/knoppix/si', $user_agent))
        {
        $client_data['system'] .= " (Knoppix)";
        }
      elseif(preg_match('/centos/si', $user_agent))
        {
        $client_data['system'] .= " (CentOS)";
        }
      elseif(preg_match('/gentoo/si', $user_agent))
        {
        $client_data['system'] .= " (Gentoo)";
        }
      elseif(preg_match('/fedora/si', $user_agent))
        {
        $client_data['system'] .= " (Fedora)";
        }
      elseif(preg_match('/ubuntu/si', $user_agent))
        {
        $client_data['system'] .= " (Ubuntu)";
        }
      elseif(preg_match('/slackware/si', $user_agent))
        {
        $client_data['system'] .= " (Slackware)";
        }
      elseif(preg_match('/suse/si', $user_agent))
        {
        $client_data['system'] .= " (Suse)";
        }
      elseif(preg_match('/redhat/si', $user_agent))
        {
        $client_data['system'] .= " (Redhat)";
        }
      elseif(preg_match('/debian/si', $user_agent))
        {
        $client_data['system'] .= " (Debian)";
        }
      elseif(preg_match('/PLD\/([0-9.]*) \(([a-z]{2})\)/si', $user_agent, $tmp_array))
        {
        $client_data['system'] .= " (PLD".($tmp_array[1] ? " ".$tmp_array[1] : "").($tmp_array[2] ? " ".$tmp_array[2] : "").")";
        }
      }

    // BSD
    if(preg_match('/bsd/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "BSD";
      if(preg_match('/freebsd/si', $user_agent))
        {
        $client_data['system'] = "FreeBSD";
        }
      elseif(preg_match('/openbsd/si', $user_agent))
        {
        $client_data['system'] = "OpenBSD";
        }
      elseif(preg_match('/netbsd/si', $user_agent))
        {
        $client_data['system'] = "NetBSD";
        }
      }

    // Mac OS (X)
    if((preg_match('/mac_/si', $user_agent) || preg_match('/macos/si', $user_agent) || preg_match('/powerpc/si', $user_agent) || preg_match('/mac os/si', $user_agent) || preg_match('/68k/si', $user_agent) || preg_match('/macintosh/si', $user_agent)) && !$client_data['system'])
    {
      $client_data['system'] = "Mac OS";
      if(preg_match('/mac os x/si', $user_agent))
        {
        $client_data['system'] .= " X";

        // if browser == safari try to detect Mac OS X version
        if(preg_match('/applewebkit\/([0-9\.]+).*/si', $user_agent, $tmp_array))
          {
          if($tmp_array[1] == "418.9.1")
            {
            $client_data['system'] .= " 10.4.8";
            }
          elseif($tmp_array[1] == "418.9")
            {
            $client_data['system'] .= " 10.4.8";
            }
          elseif($tmp_array[1] == "418.8")
            {
            $client_data['system'] .= " 10.4.7";
            }
          elseif(substr($tmp_array[1], 0, 3) == "418")
            {
            $client_data['system'] .= " 10.4.6";
            }
          elseif($tmp_array[1] == "417.9")
            {
            $client_data['system'] .= " 10.4.4/10.4.5";
            }
          elseif(substr($tmp_array[1], 0, 3) == "416")
            {
            $client_data['system'] .= " 10.4.3";
            }
          elseif(substr($tmp_array[1], 0, 4) == "412.")
            {
            $client_data['system'] .= " 10.4.2";
            }
          elseif(substr($tmp_array[1], 0, 3) == "412")
            {
            $client_data['system'] .= " 10.4/10.4.1";
            }
          elseif(substr($tmp_array[1], 0, 3) == "312")
            {
            $client_data['system'] .= " 10.3.9";
            }
          elseif($tmp_array[1] == "125.5.7")
            {
            $client_data['system'] .= " 10.3.8";
            }
          elseif($tmp_array[1] == "125.5.5" && $tmp_array[2] == "125.11")
            {
            $client_data['system'] .= " 10.3.6";
            }
          elseif(($tmp_array[1] == "125.5.6" || $tmp_array[1] == "125.5.5") && substr($tmp_array[1], 0, 5) == "125.1")
            {
            $client_data['system'] .= " 10.3.6/10.3.7/10.3.8";
            }
          elseif($tmp_array[1] == "125.5" || $tmp_array[1] == "125.4")
            {
            $client_data['system'] .= " 10.3.5";
            }
          elseif($tmp_array[1] == "125.2")
            {
            $client_data['system'] .= " 10.3.4";
            }
          elseif($tmp_array[1] == "100"  && $tmp_array[2] == "100.1")
            {
            $client_data['system'] .= " 10.3.2";
            }
          elseif(substr($tmp_array[1], 0, 3) == "100")
            {
            $client_data['system'] .= " 10.3";
            }
          elseif(substr($tmp_array[1], 0, 2) == "85")
            {
            $client_data['system'] .= " 10.2.8";
            }
          }
        }
      }

    // ReactOS
    if(preg_match('/ReactOS ([0-9a-zA-Z\+\-\. ]+).*/s', $user_agent, $tmp_array))
      {
      $client_data['system'] = "ReactOS" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // SunOs
    if(preg_match('/sunos/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "Solaris";
      }

    // Amiga
    if(preg_match('/amiga/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "Amiga";
      }

    // Irix
    if(preg_match('/irix/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "IRIX";
      }

    // OpenVMS
    if(preg_match('/open.*vms/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "OpenVMS";
      }

    // BeOs
    if(preg_match('/beos/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "BeOS";
      }

    // QNX
    if(preg_match('/QNX/si', $user_agent) && preg_match('/Photon/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "QNX";
      }

    // OS/2 Warp
    if(preg_match('/OS\/2.*Warp ([0-9.]+).*/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      $client_data['system'] = "OS/2 Warp" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    // Java on mobile
    if(preg_match('/j2me/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "Java Platform Micro Edition";
      }

    // Symbian Os
    if(preg_match('/symbian/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "Symbian OS";
      // try to get version
      if(preg_match('/SymbianOS\/([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array))
        {
	$client_data['system'] .= ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Palm Os
    if(preg_match('/palmos/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "Palm OS";
      // try to get version
      if(preg_match('/PalmOS ([0-9a-z\+\-\.]+).*/si', $user_agent, $tmp_array))
        {
	$client_data['system'] .= ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // PlayStation Portable
    if(preg_match('/psp.*playstation.*portable/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "PlayStation Portable";
      }

    // Nintentdo Wii
    if(preg_match('/Nintendo Wii/si', $user_agent) && !$client_data['system'])
      {
      $client_data['system'] = "Nintendo Wii";
      }

    // Try to detect some mobile devices...

    // Nokia
    if(preg_match('/Nokia[ ]{0,1}([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Nokia" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Nokia" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Motorola
    if(preg_match('/mot\-([0-9a-zA-Z\+\-\.]+){0,1}\//si', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Motorola" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Motorola" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Siemens
    if(preg_match('/sie\-([0-9a-zA-Z\+\-\.]+){0,1}\//si', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Siemens" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Siemens" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Samsung
    if(preg_match('/samsung\-([0-9a-zA-Z\+\-\.]+){0,1}\//si', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Samsung" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Samsung" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }
    
    // SonyEricsson & Ericsson
    if(preg_match('/SonyEricsson[ ]{0,1}([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Sony Ericsson" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Sony Ericsson" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }
    elseif(preg_match('/Ericsson[ ]{0,1}([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Ericsson" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Ericsson" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Alcatel
    if(preg_match('/Alcatel\-([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Alcatel" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Alcatel" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Panasonic
    if(preg_match('/Panasonic\-{0,1}([0-9a-zA-Z\+\-\.]+){0,1}.*/s', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Panasonic" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Panasonic" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Philips
    if(preg_match('/Philips\-([0-9a-z\+\-\@\.]+){0,1}.*/si', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Philips" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Philips" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Acer
    if(preg_match('/Acer\-([0-9a-z\+\-\.]+){0,1}.*/si', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "Acer" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / Acer" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // BlackBerry
    if(preg_match('/BlackBerry([0-9a-zA-Z\+\-\.]+){0,1}\//s', $user_agent, $tmp_array))
      {
      if(!$client_data['system'])
        {
	$client_data['system'] = "BlackBerry" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      else
        {
	$client_data['system'] .= " / BlackBerry" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
	}
      }

    // Windows 3.x, 95, 98 and other numerical
    if(preg_match('/windows ([0-9\.]+).*/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      $client_data['system'] = "Windows" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
      }

    if(preg_match('/[ \(]win([0-9\.]+).*/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      if($tmp_array[1] == "16")
        {
        $client_data['system'] = "Windows 3.x";
        }
      elseif($tmp_array[1] == "32")
        {
        $client_data['system'] = "Windows";
        }
      else
        {
        $client_data['system'] = "Windows" . ($tmp_array[1] ? " " . $tmp_array[1] : "");
        }
      }

    // Windows ME
    if(preg_match('/windows me/si', $user_agent, $tmp_array) || preg_match('/win 9x 4\.90/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      $client_data['system'] = "Windows Millenium";
      }

    // Windows CE
    if(preg_match('/windows ce/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      $client_data['system'] = "Windows CE";
      }

    // Windows XP
    if(preg_match('/windows xp/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      $client_data['system'] = "Windows XP";
      }

    // Windows NT, no version, to be sure it will catch
    if(preg_match('/windows nt/si', $user_agent, $tmp_array) || preg_match('/winnt/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      $client_data['system'] = "Windows NT";
      }

    // Windows NT with version
    if(preg_match('/windows nt ([0-9\.]+).*/si', $user_agent, $tmp_array) || preg_match('/winnt([0-9\.]+).*/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      if($tmp_array[1] == "6.0")
        {
        $client_data['system'] = "Windows Vista";
        }
      elseif($tmp_array[1] == "5.2")
        {
        $client_data['system'] = "Windows Server 2003";
        }
      elseif($tmp_array[1] == "5.1")
        {
        $client_data['system'] = "Windows XP";
        }
      elseif($tmp_array[1] == "5.0" || $tmp_array[1] == "5.01")
        {
        $client_data['system'] = "Windows 2000";
        }
      else
        {
        $client_data['system'] = "Windows NT" . ($tmp_array[1] ? " ".$tmp_array[1] : "");
        }
      }

    // Catchall for all other windozez
    if(preg_match('/windows/si', $user_agent, $tmp_array) && !$client_data['system'])
      {
      $client_data['system'] = "Windows";
      }

    return $client_data;
}
?>
