<?php
	require_once('config.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	require_once('lib/referrers.php');
	require_once('lib/user_agents.php');
	require_once('lib/controls.php');
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$report_name = 'Top Pages';

	$start_date_values = get_date_control_value($_GET, 'start_date');
	$start_date = $start_date_values[0];
	$end_date_values = get_date_control_value($_GET, 'end_date');
	$end_date = $end_date_values[0];

	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);

	$res =& $db->query('SELECT MIN(YEAR(first_hit)), MAX(YEAR(first_hit)) FROM session');
	if (PEAR::isError($res)) { die($res->getMessage()); }
	$row = $res->fetchRow(DB_FETCHMODE_ORDERED);
	$min_year = $row[0]; $max_year = $row[1];
	$res->free();
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>

<form method="get" action="pages.php">
	<input type="hidden" name="server_id" value="<?= $server_id; ?>" />
	Dates:
		<?= insert_date_control($_GET, 'start_date', $min_year, $max_year) ?>
	through
		<?= insert_date_control($_GET, 'end_date', $min_year, $max_year) ?>
	<input type="submit" name="go" value="Filter" />
</form>

<?php
	$pages = array();

	$args = array();
	$sql = 'SELECT uri, COUNT(page_hit_id) FROM page_hit';
	if (!empty($start_date))
	{
		$sql = $sql . ' WHERE TO_DAYS(hit_time) >= TO_DAYS(?)';
		array_push($args, $start_date);
	}
	if (!empty($end_date))
	{
		$sql = $sql . (!empty($start_date) ? ' AND ' : ' WHERE ');
		$sql = $sql . 'TO_DAYS(hit_time) <= TO_DAYS(?)';
		array_push($args, $end_date);
	}
	$sql = $sql . ' GROUP BY uri';
		
	$res =& $db->query($sql, $args);
	if (PEAR::isError($res)) { die($res->getMessage()); }
	while ($row =& $res->fetchRow(DB_FETCHMODE_ORDERED))
	{
		$row_parts = explode('?', $row[0]);
		$row_parts2 = explode('#', $row_parts[0]);
		$uri = $row_parts2[0];
		if (array_key_exists($uri, $pages)) { $pages[$uri] += $row[1]; }
		else { $pages[$uri] = $row[1]; }	
	}
	$res->free();
	arsort($pages);
?>

<table class="data_table" cellspacing="0">
	<tr>
		<th>URI</th>
		<th>Count</th>
	</tr>
	<?php foreach (array_keys($pages) as $page) { ?>
		<tr>
			<td><?= htmlspecialchars($page) ?></td>
			<td class="numeric"><?= $pages[$page] ?></td>
		</tr>
	<?php } ?>
</table>

<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
