<?php
	require_once('config.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	require_once('lib/referrers.php');
	require_once('lib/controls.php');
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$report_name = 'Referrers';

	$start_date_values = get_date_control_value($_GET, 'start_date');
	$start_date = $start_date_values[0];
	$end_date_values = get_date_control_value($_GET, 'end_date');
	$end_date = $end_date_values[0];

	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);

	$res =& $db->query('SELECT MIN(YEAR(first_hit)), MAX(YEAR(first_hit)) FROM session');
	if (PEAR::isError($res)) { die($res->getMessage()); }
	$row = $res->fetchRow(DB_FETCHMODE_ORDERED);
	$min_year = $row[0]; $max_year = $row[1];
	$res->free();
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>

<form method="get" action="referrers.php">
	<input type="hidden" name="server_id" value="<?= $server_id; ?>" />
	Dates:
		<?= insert_date_control($_GET, 'start_date', $min_year, $max_year) ?>
	through
		<?= insert_date_control($_GET, 'end_date', $min_year, $max_year) ?>
	<input type="submit" name="go" value="Filter" />
</form>

<?php
	$domains = array();
	$total = 0;

	$sql = 'SELECT referrer, COUNT(session_id)
			FROM session
			WHERE referrer <> "" AND referrer <> "-" ';
	$args = array();

	if (!empty($start_date))
	{
		$sql = $sql . ' AND TO_DAYS(first_hit) >= TO_DAYS(?)';
		array_push($args, $start_date);
	}
	if (!empty($end_date))
	{
		$sql = $sql . ' AND TO_DAYS(last_hit) <= TO_DAYS(?)';
		array_push($args, $end_date);
	}		
	$sql .= ' GROUP BY referrer';

	$res =& $db->query($sql, $args);
	if (PEAR::isError($res)) { die($res->getMessage()); }
	while ($row =& $res->fetchRow(DB_FETCHMODE_ORDERED))
	{
		// Save referrer domain name
		eregi("^[^:]+://([^/]+)", $row[0], $matches);
		$total += $row[1];
		if (array_key_exists($matches[1], $domains)) { $domains[$matches[1]] += $row[1]; }
		else { $domains[$matches[1]] = $row[1]; }
	}
	$res->free();
	arsort($domains);
?>

<table class="data_table" cellspacing="0">
	<tr>
		<th>Site</th>
		<th>Count</th>
	</tr>
	<tr>
		<td><a href="<?= get_report_link('referrers_by_domain.php', array(), $server_id, $start_date_values, $end_date_values) ?>">All</a></td>
		<td class="numeric"><?= $total ?></td>
	</tr>
	<?php foreach (array_keys($domains) as $domain) { ?>
		<tr>
			<td><a href="<?= get_report_link('referrers_by_domain.php', array(referrer_domain => $domain), $server_id, $start_date_values, $end_date_values) ?>"><?= htmlspecialchars($domain) ?></a></td>
			<td class="numeric"><?= $domains[$domain] ?></td>
		</tr>
	<?php } ?>
</table>
<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
