<?php
	require_once('config.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	require_once('lib/referrers.php');
	require_once('lib/controls.php');
	$new_server_url = 'referrers.php';
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$domain = !empty($_GET['referrer_domain']) ? $_GET['referrer_domain'] : '';
	$report_name = (!empty($domain)) ? $domain : 'All Referrers';

	$start_date_values = get_date_control_value($_GET, 'start_date');
	$start_date = $start_date_values[0];
	$end_date_values = get_date_control_value($_GET, 'end_date');
	$end_date = $end_date_values[0];

	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);

	$res =& $db->query('SELECT MIN(YEAR(first_hit)), MAX(YEAR(first_hit)) FROM session');
	if (PEAR::isError($res)) { die($res->getMessage()); }
	$row = $res->fetchRow(DB_FETCHMODE_ORDERED);
	$min_year = $row[0]; $max_year = $row[1];
	$res->free();
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>

<form method="get" action="referrers.php">
	<input type="hidden" name="server_id" value="<?= $server_id; ?>" />
	Dates:
		<?= insert_date_control($_GET, 'start_date', $min_year, $max_year) ?>
	through
		<?= insert_date_control($_GET, 'end_date', $min_year, $max_year) ?>
	<input type="submit" name="go" value="Filter" />
</form>

<?php
	$referrers = array();
	$total = 0;

	$sql = 'SELECT referrer, COUNT(session_id)
			FROM session
			WHERE referrer <> "" AND referrer <> "-" ';
	$args = array();

	if (!empty($domain))
	{
		$sql = $sql . ' AND (referrer REGEXP CONCAT("^[^:]+://", ?, "/") OR referrer REGEXP CONCAT("^[^:]+://", ?, "$"))';
		array_push($args, $domain); array_push($args, $domain);
	}
	if (!empty($start_date))
	{
		$sql = $sql . ' AND TO_DAYS(first_hit) >= TO_DAYS(?)';
		array_push($args, $start_date);
	}
	if (!empty($end_date))
	{
		$sql = $sql . ' AND TO_DAYS(last_hit) <= TO_DAYS(?)';
		array_push($args, $end_date);
	}		
	$sql .= ' GROUP BY referrer';

	$res =& $db->query($sql, $args);
	if (PEAR::isError($res)) { die($res->getMessage()); }
	while ($row =& $res->fetchRow(DB_FETCHMODE_ORDERED))
	{
		// Save full referrer URI
		if (array_key_exists($row[0], $referrers)) { $referrers[$row[0]] += $row[1]; }
		else { $referrers[$row[0]] = $row[1]; }
	}
	$res->free();
	arsort($referrers);
?>

<table class="data_table small_text" cellspacing="0">
	<tr>
		<th>Referrer</th>
		<th>Count</th>
	</tr>
	<?php foreach (array_keys($referrers) as $referrer) { ?>
		<tr>
			<td><?= $referrer ?></td>
			<td class="numeric"><?= $referrers[$referrer] ?></td>
		</tr>
	<?php } ?>
</table>
<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
