<?php
	require_once('config.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	require_once('lib/referrers.php');
	require_once('lib/controls.php');
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$report_name = 'Search Terms';

	$group_by = !empty($_GET['group_by']) ? $_GET['group_by'] : GROUP_BY_SEARCHTERMS;

	$start_date_values = get_date_control_value($_GET, 'start_date');
	$start_date = $start_date_values[0];
	$end_date_values = get_date_control_value($_GET, 'end_date');
	$end_date = $end_date_values[0];

	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);

	$res =& $db->query('SELECT MIN(YEAR(first_hit)), MAX(YEAR(first_hit)) FROM session');
	if (PEAR::isError($res)) { die($res->getMessage()); }
	$row = $res->fetchRow(DB_FETCHMODE_ORDERED);
	$min_year = $row[0]; $max_year = $row[1];
	$res->free();
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>

<form method="get" action="searchterms.php">
	<input type="hidden" name="server_id" value="<?= $server_id; ?>" />
	Dates:
		<?= insert_date_control($_GET, 'start_date', $min_year, $max_year) ?>
	through
		<?= insert_date_control($_GET, 'end_date', $min_year, $max_year) ?>
	<input type="submit" name="go" value="Filter" />

	&nbsp;Group By: 
	<select name="group_by">
		<option value="<?= GROUP_BY_SEARCHTERMS ?>"<?= ($group_by==GROUP_BY_SEARCHTERMS) ? ' selected' : '' ?>>Search Terms</option>
		<option value="<?= GROUP_BY_SEARCHENGINES ?>"<?= ($group_by==GROUP_BY_SEARCHENGINES) ? ' selected' : '' ?>>Search Engines</option>
	</select>
	<input type="submit" name="go2" value="Sort" />
</form>

<?php
	if ($group_by == GROUP_BY_SEARCHTERMS)
	{
		$search_header = "Search Terms";
		$link_url = "searchterms_by_term.php";
		$group_param = "search_term";
	}
	else if ($group_by == GROUP_BY_SEARCHENGINES)
	{
		$search_header = "Search Engines";
		$link_url = "searchterms_by_engine.php";
		$group_param = "search_engine";
	}
	$search_groups = array();

	for ($i = 0; $i < count($search_referrers); $i++)
	{
		$se = $search_referrers[$i];

		// Set up SQL for returning referres from particular domains
		$hostnames_sql = array();
		$hostnames_args = array();
		for ($j = 0; $j < count($se['hostnames']); $j++)
		{
			array_push($hostnames_sql, 'session.referrer LIKE ?');
			array_push($hostnames_sql, 'session.referrer LIKE ?');
			array_push($hostnames_args, 'http://' . $se['hostnames'][$j] . '%');
			array_push($hostnames_args, 'http://www.' . $se['hostnames'][$j] . '%');
		}
		
		$sql = 'SELECT referrer, COUNT(session_id) FROM session WHERE (' . implode(' OR ', $hostnames_sql) . ')';
		if (!empty($start_date))
		{
			$sql = $sql . ' AND TO_DAYS(first_hit) >= TO_DAYS(?)';
			array_push($hostnames_args, $start_date);
		}
		if (!empty($end_date))
		{
			$sql = $sql . ' AND TO_DAYS(last_hit) <= TO_DAYS(?)';
			array_push($hostnames_args, $end_date);
		}
		$sql = $sql . ' GROUP BY referrer';
		
		$res =& $db->query($sql, $hostnames_args);
		if (PEAR::isError($res)) { die($res->getMessage()); }
		while ($row =& $res->fetchRow(DB_FETCHMODE_ORDERED))
		{
			$url_parts = parse_url($row[0]);
			$params = parse_query_string($url_parts['query']);
			$keyword = $params[$se['keyword']];
			if (!empty($keyword))
			{
				if ($group_by == GROUP_BY_SEARCHTERMS)
				{
					$keyword = urldecode(str_replace('+', ' ', $keyword));
					if (array_key_exists($keyword, $search_groups)) { $search_groups[$keyword] += $row[1]; }
					else { $search_groups[$keyword] = $row[1]; }
				}
				else if ($group_by == GROUP_BY_SEARCHENGINES)
				{
					if (array_key_exists($i, $search_groups)) { $search_groups[$i] += $row[1]; }
					else { $search_groups[$i] = $row[1]; }
				}
			}
		}
		$res->free();
	}

	arsort($search_groups);
?>

<table class="data_table" cellspacing="0">
	<tr>
		<th><?= $search_header ?></th>
		<th>Count</th>
	</tr>
	<?php foreach (array_keys($search_groups) as $group) {
		$p = array(); $p[$group_param] = $group;
		$link = get_report_link($link_url, $p, $server_id, $start_date_values, $end_date_values);
	?>
		<tr>
			<td><a href="<?= $link ?>"><?= htmlspecialchars(($group_by == GROUP_BY_SEARCHENGINES) ? $search_referrers[$group]['name'] : $group) ?></a></td>
			<td class="numeric"><?= $search_groups[$group] ?></td>
		</tr>
	<?php } ?>
</table>

<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
