<?php
	require_once('config.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	require_once('lib/referrers.php');
	require_once('lib/controls.php');
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$search_engine = !empty($_GET['search_engine']) ? $_GET['search_engine'] : 0;

	$report_name = $search_referrers[$search_engine]['name'];

	$start_date_values = get_date_control_value($_GET, 'start_date');
	$start_date = $start_date_values[0];
	$end_date_values = get_date_control_value($_GET, 'end_date');
	$end_date = $end_date_values[0];

	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);

	$res =& $db->query('SELECT MIN(YEAR(first_hit)), MAX(YEAR(first_hit)) FROM session');
	if (PEAR::isError($res)) { die($res->getMessage()); }
	$row = $res->fetchRow(DB_FETCHMODE_ORDERED);
	$min_year = $row[0]; $max_year = $row[1];
	$res->free();
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>

<form method="get" action="searchterms_by_term.php">
	<input type="hidden" name="server_id" value="<?= $server_id; ?>" />
	<input type="hidden" name="search_engine" value="<?= $search_engine ?>" />
	Dates:
		<?= insert_date_control($_GET, 'start_date', $min_year, $max_year) ?>
	through
		<?= insert_date_control($_GET, 'end_date', $min_year, $max_year) ?>
	<input type="submit" name="go" value="Filter" />
</form>

<?php
	$search_groups = array();

	$se = $search_referrers[$search_engine];

	// Set up SQL for returning referres from particular domains
	$hostnames_sql = array();
	$hostnames_args = array();
	for ($j = 0; $j < count($se['hostnames']); $j++)
	{
		array_push($hostnames_sql, 'session.referrer LIKE ?');
		array_push($hostnames_sql, 'session.referrer LIKE ?');
		array_push($hostnames_args, 'http://' . $se['hostnames'][$j] . '%');
		array_push($hostnames_args, 'http://www.' . $se['hostnames'][$j] . '%');
	}
		
	$sql = 'SELECT referrer, COUNT(session_id) FROM session WHERE (' . implode(' OR ', $hostnames_sql) . ')';
	if (!empty($start_date))
	{
		$sql = $sql . ' AND TO_DAYS(first_hit) >= TO_DAYS(?)';
		array_push($hostnames_args, $start_date);
	}
	if (!empty($end_date))
	{
		$sql = $sql . ' AND TO_DAYS(last_hit) <= TO_DAYS(?)';
		array_push($hostnames_args, $end_date);
	}
	$sql = $sql . ' GROUP BY referrer';
	
	$res =& $db->query($sql, $hostnames_args);
	if (PEAR::isError($res)) { die($res->getMessage()); }
	while ($row =& $res->fetchRow(DB_FETCHMODE_ORDERED))
	{
		$url_parts = parse_url($row[0]);
		$params = parse_query_string($url_parts['query']);
		$keyword = $params[$se['keyword']];
		
		if (!empty($keyword))
		{
			if (array_key_exists($keyword, $search_groups)) { $search_groups[$keyword] += $row[1]; }
			else { $search_groups[$keyword] = $row[1]; }
		}
	}
	$res->free();

	arsort($search_groups);
?>

<table class="data_table" cellspacing="0">
	<tr>
		<th>Search Term</th>
		<th>Count</th>
	</tr>
	<?php foreach (array_keys($search_groups) as $group) { ?>
		<tr>
			<td><?= $group ?></td>
			<td class="numeric"><?= $search_groups[$group] ?></td>
		</tr>
	<?php } ?>
</table>

<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
