<?php
	require_once('config.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	require_once('lib/user_agents.php');
	require_once('lib/referrers.php');
	$new_server_url = 'index.php';
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$session_id = !empty($_GET['session_id']) ? $_GET['session_id'] : 0;
	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>
<?php include('lib/filesize.php'); ?>
<?php
	$res =& $db->query('SELECT ip_address, host_name, user_agent, referrer FROM session WHERE session_id=?', array($session_id));
	$session_data = $res->fetchRow(DB_FETCHMODE_ASSOC);
	$client_data = parse_user_agent($session_data['user_agent']);
	$referrer_data = display_referrer($session_data['referrer']);
	$res->free();
?>

<table class="data_table" cellspacing="0">
	<tr>
		<th>Hostname</th>
		<td><?= $session_data['host_name']; ?></td>
	</tr>
	<tr>
		<th>IP Address</th>
		<td><?= $session_data['ip_address']; ?></td>
	</tr>
	<tr>
		<th>User Agent</th>
		<td><?= htmlspecialchars($session_data['user_agent']) ?></td>
	</tr>
	<?php if (!empty($client_data['system']) && !empty($client_data['browser'])) { ?>
		<tr>
			<th>Operating System</th>
			<td><?= htmlspecialchars($client_data['system']) ?></td>
		</tr>
		<tr>
			<th>Browser</th>
			<td><?= htmlspecialchars($client_data['browser']) ?></td>
		</tr>
	<?php } ?>
	<tr>
		<th>Referrer</th>
		<td>
			<?php if (!empty($session_data['referrer']) && $session_data['referrer'] != '-') { ?>
			<a href="<?= htmlspecialchars($session_data['referrer']) ?>"><?= htmlspecialchars($session_data['referrer']) ?></a>
			<?php } ?>
			&nbsp;
		</td>
	</tr>
	<?php if ($referrer_data != $session_data['referrer']) { ?>
		<tr>
			<th>Search Engine</th>
			<td><?= $referrer_data ?></td>
		</tr>
	<?php } ?>
</table>
<br />
<table class="data_table" cellspacing="0">
	<tr>
		<th>Time</th>
		<th>Method</th>
		<th>Status</th>
		<th>URI</th>
		<th>Bytes Sent</th>
	</tr>
	<?php
		$res =& $db->query('SELECT DATE_FORMAT(hit_time, "%m/%d/%Y %h:%i %p") AS formatted_hit_time,
								   http_method, http_status, bytes_sent, uri
							FROM page_hit
							WHERE session_id=?
							ORDER BY hit_time', array($session_id));
		if (PEAR::isError($res)) { die ($res->getMessage()); }
		$count = 0;
		while ($row =& $res->fetchRow(DB_FETCHMODE_ASSOC))
		{
			?><tr<?= ($count % 2 == 1) ? ' class="altRow"' : '' ?>>
				<td><?= $row['formatted_hit_time'] ?></td>
				<td><?= $row['http_method'] ?></td>
				<td><?= $row['http_status'] ?></td>
				<td><?= htmlspecialchars($row['uri']) ?></td>
				<td align="right"><?= display_file_size($row['bytes_sent']) ?></td>
			</tr><?php
		}
		$res->free();
	?>
</table>

<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
