<?php
	require_once('config.php');
	require_once('lib/database.php');
	require_once('lib/links.php');
	require_once('lib/referrers.php');
	require_once('lib/user_agents.php');
	$new_server_url = 'index.php';
	$server_id = !empty($_GET['server_id']) ? $_GET['server_id'] : 0;
	$group_by = !empty($_GET['group_by']) ? $_GET['group_by'] : 'DATE';
	$date = !empty($_GET['date']) ? $_GET['date'] : '';
	$db = websessions_db_connect($WEBSESSIONS_SERVERS, $server_id);
?>
<?php include('include/htmlheader.php') ?>
<?php include('include/header.php'); ?>

<table class="data_table small_text" cellspacing="0">
	<tr>
		<th>&nbsp;</th>
		<th>Hostname</th>
		<th>User Agent</th>
		<th>Referrer</th>
		<th>Entry Page</th>
		<th>First Hit</th>
		<th>Page Views</th>
	</tr>
	<?php
		$res =& $db->query('SELECT session.session_id, IF(session.host_name="", session.ip_address, session.host_name) AS host_name,
								   session.user_agent, session.referrer, DATE_FORMAT(session.first_hit, "%m/%d/%Y %h:%i %p") AS first_hit,
								   first_page_hit.uri AS entry_page, COUNT(page_hit.page_hit_id) AS page_views
							FROM session, page_hit AS first_page_hit, page_hit
							WHERE session.first_hit_id=first_page_hit.page_hit_id
							AND session.session_id=page_hit.session_id
							AND TO_DAYS(session.first_hit)=TO_DAYS(?)
							GROUP BY session.session_id
							ORDER BY session.first_hit', array($date));
		if (PEAR::isError($res)) { die($res->getMessage()); }
		$count = 0;
		while($row =& $res->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$link = get_websessions_link('session.php', $server_id, $group_by, $date, null, $row['session_id']);
			$client_data = parse_user_agent($row['user_agent']);
			?>
			<tr<?= ($count % 2 == 1) ? ' class="altRow"' : ''?>>
				<td><a href="<?= $link ?>"><img src="images/magnifier.png" alt="View" /></a></td>
				<td><?= $row['host_name'] ?></td>
				<td>
					<?php if (!empty($client_data['system']) && !empty($client_data['browser'])) { ?>
						OS: <?= htmlspecialchars($client_data['system']) ?><br />
						Browser: <?= htmlspecialchars($client_data['browser']) ?>
					<?php } else { ?>
						<?= htmlspecialchars($row['user_agent']) ?>
					<?php } ?>&nbsp;
				</td>
				<td>
					<?php if (!empty($row['referrer']) && $row['referrer'] != '-') { ?>
					<a href="<?= htmlspecialchars($row['referrer']) ?>"><?= display_referrer($row['referrer']) ?></a>
					<?php } ?>
					&nbsp;
				</td>
				<td><?= htmlspecialchars($row['entry_page']) ?></td>
				<td><?= $row['first_hit'] ?></td>
				<td><?= $row['page_views'] ?></td>
			</tr><?php
		}
		$res->free();
	?>
</table>

<?php include('include/footer.php'); ?>
<?php websessions_db_close($db); ?>
